SystemOrganization addCategory: #ConfigurationOfPomodoro!

Object subclass: #ConfigurationOfPomodoro
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPomodoro'!

!ConfigurationOfPomodoro class methodsFor: 'development support' stamp: 'tbn 2/28/2013 08:58'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPomodoro class methodsFor: 'private' stamp: 'tbn 2/28/2013 08:58'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPomodoro class methodsFor: 'private' stamp: 'tbn 2/28/2013 08:58'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPomodoro class methodsFor: 'private' stamp: 'tbn 2/28/2013 08:58'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPomodoro class methodsFor: 'metacello tool support' stamp: 'tbn 2/28/2013 08:58'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPomodoro class methodsFor: 'loading' stamp: 'tbn 2/28/2013 08:58'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPomodoro class methodsFor: 'loading' stamp: 'tbn 2/28/2013 08:58'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPomodoro class methodsFor: 'loading' stamp: 'tbn 2/28/2013 08:58'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPomodoro class methodsFor: 'accessing' stamp: 'tbn 2/28/2013 08:58'!
project

	^self new project! !

!ConfigurationOfPomodoro class methodsFor: 'development support' stamp: 'tbn 2/28/2013 08:58'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPomodoro methodsFor: 'baselines' stamp: 'tbn 3/26/2013 17:10'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'pharo' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/TorstenBergmann/Pomodoro/main'.
		spec package: 'Pomodoro'].
		
		
	 ! !

!ConfigurationOfPomodoro methodsFor: 'accessing' stamp: 'tbn 2/28/2013 08:58'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfPomodoro methodsFor: 'symbolic versions' stamp: 'tbn 3/26/2013 17:07'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfPomodoro methodsFor: 'doits' stamp: 'tbn 3/26/2013 17:05'!
postloadForCore: loader package: packageSpec
	 
	(Smalltalk at: #Pomodoro) new open! !

!ConfigurationOfPomodoro methodsFor: 'accessing' stamp: 'tbn 2/28/2013 08:58'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPomodoro methodsFor: 'symbolic versions' stamp: 'tbn 2/28/2013 08:59'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfPomodoro methodsFor: 'versions' stamp: 'tbn 3/26/2013 17:21'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'First release'.
		spec author: 'tbn'.
		spec timestamp: '3/25/2013 08:58'.
		spec package: 'Pomodoro' with: 'Pomodoro-tbn.15'. 
		"postload"
		spec postLoadDoIt: #postloadForCore:package:.
	].

! !

!ConfigurationOfPomodoro methodsFor: 'versions' stamp: 'tbn 3/26/2013 17:21'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'current development'.
		spec author: 'tbn'.
		spec timestamp: '3/25/2013 08:58'.
		spec package: 'Pomodoro' with: 'Pomodoro-tbn.15'. 
		"postload"
		spec postLoadDoIt: #postloadForCore:package:.
	].

! !
